﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_array_to_string
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnConvert_Click(object sender, EventArgs e)
        {
            Random rand = new Random();
            int num_items = int.Parse(txtNumItems.Text); ;
            string delimiter;

            // int
            delimiter = "; ";
            int[] ints = new int[num_items];
            for (int i = 0; i < num_items; i++)
                ints[i] = rand.Next(10, 100);
            string ints_string = ints.Join(delimiter);
            txtInt.Text = ints_string;
            
            int[] new_ints = ints_string.SplitInts(
                delimiter, StringSplitOptions.RemoveEmptyEntries);
            lstInt.DataSource = new_ints;
            Debug.Assert(ints.Length == new_ints.Length);
            for (int i = 0; i < new_ints.Length; i++)
            {
                Debug.Assert(ints[i] == new_ints[i]);
            }

            // float
            delimiter = "; ";
            float[] floats = new float[num_items];
            for (int i = 0; i < num_items; i++)
                floats[i] = (float)Math.Round(rand.NextDouble(), 2);
            string floats_string = floats.Join(delimiter);
            txtFloat.Text = floats_string;

            float[] new_floats = floats_string.SplitFloats(
                delimiter, StringSplitOptions.RemoveEmptyEntries);
            lstFloat.DataSource = new_floats;
            Debug.Assert(floats.Length == new_floats.Length);
            for (int i = 0; i < new_floats.Length; i++)
            {
                Debug.Assert(Math.Abs(floats[i] - new_floats[i]) < 0.1f);
            }

            // string
            delimiter = "-";
            int char_a = (int)'A';
            int char_z = (int)'Z';
            string[] strings = new string[num_items];
            for (int i = 0; i < num_items; i++)
            {
                strings[i] = "";
                for (int j = 0; j < 3; j++)
                {
                    strings[i] += (char)rand.Next(char_a, char_z + 1);
                }
            }
            string strings_string = strings.Join(delimiter);
            txtStrings.Text = strings_string;

            string[] new_strings = strings_string.Split(
                delimiter, StringSplitOptions.RemoveEmptyEntries);
            lstStrings.DataSource = new_strings;
            Debug.Assert(strings.Length == new_strings.Length);
            for (int i = 0; i < new_strings.Length; i++)
            {
                Debug.Assert(strings[i] == new_strings[i]);
            }
        }
    }
}
